class DimensionChangerDirective {
    static init() {
        return  [
            'ux-controls.services.$dom',
            'plugin-DimensionChanger.services.dimensionChangerService',
            function($dom, $dcService) {

                function linkFunction($scope, lmnt, attrs) {

                    $scope.selectedWidgets = $dcService.getSelectedWidgets($scope.$parent.widget);
                    if (!$scope.selectedWidgets && prism.activeWidget.style.selectedWidgets === undefined) {
                        $dcService.setSelectedWidgets($scope.$parent.widget, []);
                    }

                    $scope.showAvailableWidgets = function($event) {
                        $dom.menu({
                            name: 'widgets',
                            items: $dcService.getWidgetsItemsForMenu($scope.$parent.widget),
                            scope: $scope,
                            ok: ok
                        }, {
                            target: $event.currentTarget,
                            anchor: 'l'
                        })
                    };

                    $scope.remove = function(index) {
                        $scope.selectedWidgets = $dcService.removeWidget($scope.$parent.widget, index);
                    };

                    $scope.onWidgetChange = function(widget, index) {
                        $scope.selectedWidgets = $dcService.updateWidget($scope.$parent.widget, widget, index);
                    };

                    function ok(widget) {
                        $scope.selectedWidgets = $dcService.addWidget($scope.$parent.widget, widget);
                    }
                }

                return {
                    restrict: 'C',
                    templateUrl: "/plugins/DimensionChanger/views/widgetSelection.html",
                    scope: {},
                    link: linkFunction
                }
            }
        ]
    }
}
mod.directive('widgetSelection', DimensionChangerDirective.init());