prism.run(['$dashboard', function($dashboard){

	prism.on("beforemenu", function(event, args){
		if(prism.user.userAuth.base.isConsumer && mod.disableForViewers){
			return; // skip if user is a viewer and viewers are not allowed to see the menu item.
		}

		if(args.settings.name == "widgetindashboard") {
			var widget =  args.settings.scope.widget;				
			args.settings.items.push({type: 'separator'});
			args.settings.items.push({
				caption: 'Distribute equally in this row',
				id:'resizeRow',
				execute: function(){
					resizeRow(widget.oid);
				}
			});
		}
	});

	function resizeRow(wid){
		// This function sets the sizes of the widgets of a row. Setps:
		// 1. Find the row in which the widget is located
		// 2. Set the width of all the widgets by dividing 100 in the number of widgets
		// 3. Store the new size values

		var listOfWidgets = [];  // list of all widgets in the dashboard with column index, cell index, subcell index, and widgetId

		
		// 1.a Find the row in which the widget is located
		_.each(prism.activeDashboard.layout.columns, function(column, columnIndex){
			_.each(column.cells, function(cell, cellIndex){
				_.each(cell.subcells, function(subcell, subcellIndex, subcellList){
					listOfWidgets.push({column: columnIndex, cell: cellIndex, subcell: subcell.index, subcells: subcellList.length, widgetid: subcell.elements[0].widgetid})
				})
			})
		});

		
		// 1.b Assign to the variable 'w' the widget of the row that needs to be adjusted
		var w = _.find(listOfWidgets, function(element){return element.widgetid == wid});

		
		// 2. Set the width of all the widgets by dividing 100 in the number of widgets
		_.each(prism.activeDashboard.layout.columns[w.column].cells[w.cell].subcells, function(subcell){
			subcell.width = 100 / w.subcells;
		});

		
		// 3. Save the new size values and redraw the widgets in the affected row		
		$dashboard.updateDashboard(prism.activeDashboard, 'layout');	
		
		_.each(_.where(listOfWidgets, {column: w.column, cell: w.cell}), function(w){
			setTimeout(function(){

				var widgetIndex = _.findIndex(prism.activeDashboard.widgets.$$widgets, function(dashboardWidget) {
					return w.widgetid == dashboardWidget.oid
				});

				prism.activeDashboard.widgets.$$widgets[widgetIndex].redraw();
			}, 500);				
		});
	}
}]);